<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Front End</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>
<body class="hold-transition sidebar-mini">
<div class="wrapper">
  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Front End</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">haiongngoai</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-table"></i>
              <p>
                Quản trị
                <i class="fas fa-angle-left right"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.voucher.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Vouchers</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.menu.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menus</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.drink.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drinks</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.countryregion.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Country/Region</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.userorder.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>User/Order</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-12 text-center">
            <h1>Quản trị Menu</h1>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <div class="card">
              <div class="card-body">
                <div class="container">
                  <div class="jumbotron container">
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label>ID</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="number" id="input-id" class="form-control" disabled>
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label >Size</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-size" class="form-control">
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label >Đường kính</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="number" id="input-duongKinh" class="form-control">
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label>Salad</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="number" id="input-salad" class="form-control">
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label >Số lượng nước</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="number" id="input-so-luong-nuoc" class="form-control">
                    </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-3">
                        <label >Sườn nướng</label>
                      </div>
                      <div class="col-sm-9">
                        <input type="number" id="input-suon" class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-3">
                        <label >Đơn giá</label>
                      </div>
                      <div class="col-sm-9">
                        <input type="number" id="input-price" class="form-control">
                      </div>
                    </div>
                    <div class="row pull-right">
                    <div class="col-sm-12 text-right">
                      <button id="btn-create-menu" class="btn btn-info">Add menu</button>
                      <button id="btn-update-menu" class="btn btn-success my-3">Update menu</button>
                      <button id="btn-delete-menu" class="btn btn-danger">Delete menu</button>
                    </div>
                    </div>
                  </div>
                </div>
                <table class="table table-bordered table-striped table-hover text-center" id="menu-table">
                  <thead>
                    <tr>
                      <th>ID</th>
                      <th>Size</th>
                      <th>Đường kính</th>
                      <th>Salad</th>
                      <th>Số lượng nước</th>
                      <th>Sườn nướng</th>
                      <th>Đơn giá</th>
                    </tr>
                    <tbody>

                    </tbody>
                </table>
              </div>
            </div>
            <!-- /.card -->
          </div>
          <!-- /.col -->
        </div>
        <!-- /.row -->
      </div>
      <!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- DataTables  & Plugins -->
<script src="plugins/datatables/jquery.dataTables.min.js"></script>
<script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="plugins/jszip/jszip.min.js"></script>
<script src="plugins/pdfmake/pdfmake.min.js"></script>
<script src="plugins/pdfmake/vfs_fonts.js"></script>
<script src="plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
</body>
<script>
  $(document).ready(function(){
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gCOL_ID = 0;
    const gCOL_SIZE = 1;
    const gCOL_DUONG_KINH = 2;
    const gCOL_SALAD = 3;
    const gCOL_SO_LUONG_NUOC = 4;
    const gCOL_SUON = 5;
    const gCOL_pRICE = 6;
    var STT = 1;
    var gId = 0;
 
    const gORDER_COLS = ["id", "size", "duongKinh", "salad", "soLuongNuocNgot", "suon", "donGia"];
    var vTable = $("#menu-table").DataTable({
        columns: [
            {data: gORDER_COLS[gCOL_ID]},
            {data: gORDER_COLS[gCOL_SIZE]},
            {data: gORDER_COLS[gCOL_DUONG_KINH]},
            {data: gORDER_COLS[gCOL_SALAD]},
            {data: gORDER_COLS[gCOL_SO_LUONG_NUOC]},
            {data: gORDER_COLS[gCOL_SUON]},
            {data: gORDER_COLS[gCOL_pRICE]}
        ],
        columnDefs: [
            {
              targets: gCOL_ID,
              render: function (){
                return STT++;
              }
            }
        ],
        searching: false,
    });
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    //Gán event handler khi click vào hàng bất kỳ
    $("#menu-table").on("click", "td", function() {
			onTableRowClick(this);
		});
    // gán sự kiện cho nút add menu
    $("#btn-create-menu").on("click", function() {
        onBtnCreateMenuClick();
    }); 
    // gán sự kiện cho nút update menu
    $("#btn-update-menu").on("click", function() {
      onBtnUpdateMenuClick();
    });
    // gán sự kiện cho nút delete menu
    $("#btn-delete-menu").on("click", function() {
      onBtnDeleteMenuClick();
    }); 
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm load trang
    function onPageLoading() {
      "use strict";
      callApiGetAllMenuShowOnTable();
    }
    //Hàm gọi APi lấy ra toàn bộ menu
    function callApiGetAllMenuShowOnTable(){
      "use strict";
      $.ajax({
        async: false,
        url: "http://localhost:8080/menu/all",
        type: "GET",
        dataType: "json",
        success: function(res){
            console.log(res);
            vTable.clear();
            vTable.rows.add(res);
            vTable.draw();
        },
        error: function(err){
            console.log(err.responseText);
        }
      })
    }
    //Hàm thực thi khi click vào hàng bất kỳ
    function onTableRowClick(paramTableCell) {
			var vClickedRow = $(paramTableCell).parents("tr");
			var vRowData = vTable.row(vClickedRow).data();
			gId = vRowData.id;			
			console.log("Đã click vào row có id là: " + gId);
			callAjaxApiGetMenuById(gId);
		}
    //Hàm thực thi khi nhấn nút Add menuu
    function onBtnCreateMenuClick(){
      "uses strict";
      var vObj = {
				size: "",
				duongKinh: "",
				salad: "",
        soLuongNuocNgot: "",
        suon: "",
        donGia: "",
			};
      readDataFromWeb(vObj);
      var vCheck = validateData(vObj);
      if(vCheck){
        $.ajax({
				url: "http://localhost:8080/menu/create",
				type: "POST",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(vObj),
				success: function(res) {
					console.log(res);
          alert("tạo menu thành công");
					window.location.reload();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
      }
    }
    //Hàm thực thi khi nhấn nút Save menu
    function onBtnUpdateMenuClick(){
      "use strict";
      if(gId == 0) {
				alert("Hãy click chọn hàng cần update");
			}
			else {
				var vObj = {
				size: "",
				duongKinh: "",
				salad: "",
        soLuongNuocNgot: "",
        suon: "",
        donGia: "",
        };
        readDataFromWeb(vObj);
        var vCheck = validateData(vObj);
        if(vCheck){
          $.ajax({
            url: "http://localhost:8080/menu/update/" + gId,
            type: "PUT",
            contentType: "application/json; charset=UTF-8",
            data: JSON.stringify(vObj),
            success: function(res) {
              console.log(res);
              alert("update menu thành công");
              window.location.reload();
            },
            error: function(err){
              console.log(err.responseText);
				    }
			    });
        };
			}
    }
    //Hàm thực thi khi nhấn nút Delete
    function onBtnDeleteMenuClick(){
      "use strict";
      if(gId == 0) {
				alert("Hãy click chọn hàng cần delete");
			}
			else if(confirm( "Ban có muõn xóa?") == true){
        $.ajax({
          url: "http://localhost:8080/menu/delete/" + gId,
          type: "DELETE",
          dataType: "json",
          success: function(res) {
            console.log(res);
            alert("delete menu thành công");
            window.location.reload();
          },
          error: function(err){
            console.log(err.responseText);
          }
        });
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm gọi API để lấy dữ liệu menu theo id
    function callAjaxApiGetMenuById(paramId) {
			$.ajax({
				url: "http://localhost:8080/menu/detail/" + paramId,
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					loadDataToForm(res);
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
    //Hàm load dữ liệu lên form
    function loadDataToForm(paramRes) {
			$("#input-id").val(paramRes.id);
			$("#input-size").val(paramRes.size);
			$("#input-duongKinh").val(paramRes.duongKinh);
      $("#input-salad").val(paramRes.salad);
      $("#input-so-luong-nuoc").val(paramRes.soLuongNuocNgot);
      $("#input-suon").val(paramRes.suon);
      $("#input-price").val(paramRes.donGia);
    }
    //Hàm thu thập dữ liệu để add
    function readDataFromWeb(paramObj) {
      "use strict";
			paramObj.size = ($("#input-size").val().trim()).toUpperCase();
			paramObj.duongKinh = $("#input-duongKinh").val().trim();
			paramObj.salad = $("#input-salad").val().trim();	
      paramObj.soLuongNuocNgot = $("#input-so-luong-nuoc").val().trim();	
      paramObj.suon = $("#input-suon").val().trim();	
      paramObj.donGia = $("#input-price").val().trim();	
		}
    //Hàm validate
    function validateData(paramObj){
      "use strict"
      if(paramObj.size === "" || paramObj.size.length > 1) {
        alert("Hãy nhập dữ liệu ô kích cỡ , bằng 1 từ duy nhất");
        return false;
      } else if(paramObj.duongKinh === "") {
        alert("Hãy nhập dữ liệu ô đường kính");
        return false;
      } else if(paramObj.salad === "") {
        alert("Hãy nhập dữ liệu ô salad");
        return false;
      } else if(paramObj.soLuongNuocNgot === "") {
        alert("Hãy nhập dữ liệu ô số lượng nước");
        return false;
      } else if(paramObj.suon === "") {
        alert("Hãy nhập dữ liệu ô sườn");
        return false;
      } else if(paramObj.donGia == "") {
        alert("Hãy nhập dữ liệu ô đơn giá");
        return false;
      } else if(isNaN(paramObj.donGia)) {
        alert("dữ liệu ô đơn giá phải là số");
        return false;
      }
      return true;
    }
      
      
  });
</script>
</html>
